#include <boost/thread.hpp>
#include <string>


enum state
{
  thinking,
  eating
};

class philosopher
{
public:
  philosopher(int id_i,
              boost::mutex& left_i,
              boost::mutex& right_i);
  void begin();

private:
  boost::thread action, hunger;

  void busy(int loops=1);
  void eat();
  void think();

  void loop();
  void hungry();

  int id;

  double bellyfull;
  bool full, starved;

  boost::mutex &left, &right;
  state s;
};
