import Control.Monad.ST
import Control.Monad
import Data.STRef
import Data.Array.ST

levenshtein :: String -> String -> Int
levenshtein a b = runST $ do
    let asize = length a
    let bsize = length b
    prevrow <- newArray_ (0, bsize) :: ST s (STArray s Int Int)
    forM_ [0 .. bsize] $ \i -> do
        writeArray prevrow i i
    thisrow <- newArray (0, bsize) 0
    prevrowp <- newSTRef prevrow
    thisrowp <- newSTRef thisrow
    forM_ [1 .. asize] $ \i -> do
        thisrow <- readSTRef thisrowp
        prevrow <- readSTRef prevrowp
        writeArray thisrow i 0
        forM_ [1 .. bsize] $ \j -> do
            x <- readArray prevrow (j - 1)
            y <- readArray prevrow j
            z <- readArray thisrow (j - 1)
            let t = if (a !! (i - 1)) /= (b !! (j - 1)) then 1 else 0
            writeArray thisrow j $ min (x + t) (1 + min y z)
            return ()
        writeSTRef prevrowp thisrow
        writeSTRef thisrowp prevrow
    prevrow <- readSTRef prevrowp
    readArray prevrow bsize
    
main = print $ levenshtein (show [1..1000]) (show [2..1001]) 